org.apache.tinkerpop.gremlin.process.traversal.traverser

## Class O_OB_S_SE_SL_Traverser<T>

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.traverser.util.AbstractTraverser<T>
  - - org.apache.tinkerpop.gremlin.process.traversal.traverser.O_Traverser<T>
    - - org.apache.tinkerpop.gremlin.process.traversal.traverser.O_OB_S_SE_SL_Traverser<T>

- All Implemented Interfaces:
    Serializable, Cloneable, Comparable<Traverser<T>>, Traverser<T>, Traverser.Admin<T>, Attachable<T>
  Direct Known Subclasses:
    LP_O_OB_P_S_SE_SL_Traverser, LP_O_OB_S_SE_SL_Traverser, NL_O_OB_S_SE_SL_Traverser

      public class O_OB_S_SE_SL_Traverser<T>
      extends O_Traverser<T>

  Author:
    Marko A. Rodriguez (http://markorodriguez.com)
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Traverser

      `Traverser.Admin<T>`

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.structure.util.Attachable

      `Attachable.Exceptions, Attachable.Method`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected long` | `bulk`
    `protected String` | `future`
    `protected String` | `loopName`
    `protected short` | `loops`
    `protected Object` | `sack`
    `protected TraversalSideEffects` | `sideEffects`

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.traverser.O_Traverser

      `tags`

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.traverser.util.AbstractTraverser

      `t`

    - ### Fields inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Traverser.Admin

      `HALT`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `O_OB_S_SE_SL_Traverser()`
    `` | `O_OB_S_SE_SL_Traverser(T t, Step<T,?> step)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `long` | `bulk()` A traverser may represent a grouping of traversers to allow for more efficient data propagation.
    `protected boolean` | `equals(O_OB_S_SE_SL_Traverser other)`
    `boolean` | `equals(Object object)`
    `TraversalSideEffects` | `getSideEffects()` Get the sideEffects associated with the traversal of the traverser.
    `String` | `getStepId()` Get the step id of where the traverser is located.
    `int` | `hashCode()`
    `void` | `incrLoops()` Increment the number of times the traverser has gone through a looping section of traversal.
    `void` | `initialiseLoops(String stepLabel, String loopName)` Initialise a loop by setting up the looping construct.
    `int` | `loops()` Return the number of times the traverser has gone through a looping section of a traversal.
    `int` | `loops(String loopName)` Return the number of times the traverser has gone through the named looping section of a traversal.
    `void` | `merge(Traverser.Admin<?> other)` When two traversers are have equality with each other, then they can be merged.
    `void` | `resetLoops()` Set the number of times the traverser has gone through a loop back to 0.
    `<S> S` | `sack()` Get the sack local sack object of this traverser.
    `<S> void` | `sack(S object)` Set the traversers sack object to the provided value ("sack the value").
    `void` | `setBulk(long count)` Set the number of traversers represented by this traverser.
    `void` | `setSideEffects(TraversalSideEffects sideEffects)` Set the sideEffects of the `Traversal`.
    `void` | `setStepId(String stepId)` Set the step id of where the traverser is located.
    `Traverser.Admin<T>` | `split()` Generate a sibling traverser of the current traverser with a full copy of all state within the sibling.
    `<R> Traverser.Admin<R>` | `split(R r, Step<T,R> step)` Generate a child traverser of the current traverser for current as step and new object location.

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.traverser.O_Traverser

      `equals, getTags`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.traverser.util.AbstractTraverser

      `addLabels, attach, clone, detach, dropLabels, dropPath, get, keepLabels, path, set, toString`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Traverser.Admin

      `isHalted`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Traverser

      `asAdmin, compareTo, path, path, sideEffects, sideEffects`

- - ### Field Detail

    - #### sack

          protected Object sack

    - #### loops

          protected short loops

    - #### loopName

          protected String loopName

    - #### sideEffects

          protected transient TraversalSideEffects sideEffects

    - #### future

          protected String future

    - #### bulk

          protected long bulk

  - ### Constructor Detail

    - #### O_OB_S_SE_SL_Traverser

          protected O_OB_S_SE_SL_Traverser()

    - #### O_OB_S_SE_SL_Traverser

          public O_OB_S_SE_SL_Traverser(T t,
                                        Step<T,?> step)

  - ### Method Detail

    - #### setBulk

          public void setBulk(long count)

      Description copied from interface: `Traverser.Admin`
      Set the number of traversers represented by this traverser.
      Specified by:
        `setBulk` in interface `Traverser.Admin<T>`
      Overrides:
        `setBulk` in class `AbstractTraverser<T>`
      Parameters:
        `count` - the number of traversers

    - #### bulk

          public long bulk()

      Description copied from interface: `Traverser`
      A traverser may represent a grouping of traversers to allow for more efficient data propagation.
      Specified by:
        `bulk` in interface `Traverser<T>`
      Overrides:
        `bulk` in class `AbstractTraverser<T>`
      Returns:
        the number of traversers represented in this traverser.

    - #### sack

          public <S> S sack()

      Description copied from interface: `Traverser`
      Get the sack local sack object of this traverser.
      Specified by:
        `sack` in interface `Traverser<T>`
      Overrides:
        `sack` in class `AbstractTraverser<T>`
      Type Parameters:
        `S` - the type of the sack object
      Returns:
        the sack object

    - #### sack

          public <S> void sack(S object)

      Description copied from interface: `Traverser`
      Set the traversers sack object to the provided value ("sack the value").
      Specified by:
        `sack` in interface `Traverser<T>`
      Overrides:
        `sack` in class `AbstractTraverser<T>`
      Type Parameters:
        `S` - the type of the object
      Parameters:
        `object` - the new value of the traverser's sack

    - #### loops

          public int loops()

      Description copied from interface: `Traverser`
      Return the number of times the traverser has gone through a looping section of a traversal.
      Specified by:
        `loops` in interface `Traverser<T>`
      Overrides:
        `loops` in class `AbstractTraverser<T>`
      Returns:
        The number of times the traverser has gone through a loop

    - #### loops

          public int loops(String loopName)

      Description copied from interface: `Traverser`
      Return the number of times the traverser has gone through the named looping section of a traversal.
      Specified by:
        `loops` in interface `Traverser<T>`
      Overrides:
        `loops` in class `AbstractTraverser<T>`
      Parameters:
        `loopName` - the name applied to the loop or null for the containing loop
      Returns:
        The number of times the traverser has gone through a loop

    - #### initialiseLoops

          public void initialiseLoops(String stepLabel,
                                      String loopName)

      Description copied from interface: `Traverser.Admin`
      Initialise a loop by setting up the looping construct. The step label is important to create a stack of loop counters when within a nested context. If the provided label is not the same as the current label on the stack, add a new loop counter. The loopName can be used to refer to the loops counter via the `LoopsStep`
      Specified by:
        `initialiseLoops` in interface `Traverser.Admin<T>`
      Overrides:
        `initialiseLoops` in class `AbstractTraverser<T>`
      Parameters:
        `stepLabel` - the label of the step that is being set-up.
        `loopName` - the user defined name for referencing the loop counter or null if not set

    - #### incrLoops

          public void incrLoops()

      Description copied from interface: `Traverser.Admin`
      Increment the number of times the traverser has gone through a looping section of traversal.
      Specified by:
        `incrLoops` in interface `Traverser.Admin<T>`
      Overrides:
        `incrLoops` in class `AbstractTraverser<T>`

    - #### resetLoops

          public void resetLoops()

      Description copied from interface: `Traverser.Admin`
      Set the number of times the traverser has gone through a loop back to 0. When a traverser exits a looping construct, this method should be called. In a nested loop context, the highest stack loop counter should be removed.
      Specified by:
        `resetLoops` in interface `Traverser.Admin<T>`
      Overrides:
        `resetLoops` in class `AbstractTraverser<T>`

    - #### getStepId

          public String getStepId()

      Description copied from interface: `Traverser.Admin`
      Get the step id of where the traverser is located. This is typically used in multi-machine systems that require the movement of traversers between different traversal instances.
      Specified by:
        `getStepId` in interface `Traverser.Admin<T>`
      Overrides:
        `getStepId` in class `AbstractTraverser<T>`
      Returns:
        The future step for the traverser

    - #### setStepId

          public void setStepId(String stepId)

      Description copied from interface: `Traverser.Admin`
      Set the step id of where the traverser is located. If the future is `Traverser.Admin.HALT`, then `Traverser.Admin.isHalted()` is true.
      Specified by:
        `setStepId` in interface `Traverser.Admin<T>`
      Overrides:
        `setStepId` in class `AbstractTraverser<T>`
      Parameters:
        `stepId` - The future step of the traverser

    - #### getSideEffects

          public TraversalSideEffects getSideEffects()

      Description copied from interface: `Traverser.Admin`
      Get the sideEffects associated with the traversal of the traverser.
      Specified by:
        `getSideEffects` in interface `Traverser.Admin<T>`
      Overrides:
        `getSideEffects` in class `AbstractTraverser<T>`
      Returns:
        the traversal sideEffects of the traverser

    - #### setSideEffects

          public void setSideEffects(TraversalSideEffects sideEffects)

      Description copied from interface: `Traverser.Admin`
      Set the sideEffects of the `Traversal`. Given that traversers can move between machines, it may be important to re-set this when the traverser crosses machine boundaries.
      Specified by:
        `setSideEffects` in interface `Traverser.Admin<T>`
      Overrides:
        `setSideEffects` in class `AbstractTraverser<T>`
      Parameters:
        `sideEffects` - the sideEffects of the traversal.

    - #### split

          public <R> Traverser.Admin<R> split(R r,
                                              Step<T,R> step)

      Description copied from interface: `Traverser.Admin`
      Generate a child traverser of the current traverser for current as step and new object location. The child has the path history, future, and loop information of the parent. The child extends that path history with the current as and provided R-object.
      Specified by:
        `split` in interface `Traverser.Admin<T>`
      Overrides:
        `split` in class `O_Traverser<T>`
      Type Parameters:
        `R` - The current object type of the child
      Parameters:
        `r` - The current object of the child
        `step` - The step yielding the split
      Returns:
        The split traverser

    - #### split

          public Traverser.Admin<T> split()

      Description copied from interface: `Traverser.Admin`
      Generate a sibling traverser of the current traverser with a full copy of all state within the sibling.
      Specified by:
        `split` in interface `Traverser.Admin<T>`
      Overrides:
        `split` in class `O_Traverser<T>`
      Returns:
        The split traverser

    - #### merge

          public void merge(Traverser.Admin<?> other)

      Description copied from interface: `Traverser.Admin`
      When two traversers are have equality with each other, then they can be merged. This method is used to merge the traversers into a single traverser. This is used for optimization where instead of enumerating all traversers, they can be counted.
      Specified by:
        `merge` in interface `Traverser.Admin<T>`
      Overrides:
        `merge` in class `O_Traverser<T>`
      Parameters:
        `other` - the other traverser to merge into this traverser. Once merged, the other can be garbage collected.

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `O_Traverser<T>`

    - #### equals

          protected final boolean equals(O_OB_S_SE_SL_Traverser other)

    - #### equals

          public boolean equals(Object object)

      Overrides:
        `equals` in class `O_Traverser<T>`

Copyright © 2013–2022 Apache Software Foundation. All rights reserved.